﻿//【登録場所】リンク、URLExec
//【ラベル】Youtube動画情報
//【内容】Youtube動画情報のポップアップ
//【コマンド】${SCRIPT:FrS} PopupStatusYoutube.js
//【URLExec】http://www\.youtube\.com/watch(_videos)?\?v=[\-\w]{11}(.+)?【tab】$&【tab】${V2CSCRIPT:FrS} PopupStatusYoutube.js
//【スクリプト】
// ----- 次の行から -----
//設定
closePopup = true;		//リンククリックでポップアップを閉じる
browseExt = false;		//外部ブラウザで開く（falseだとJDICがあれば内部ブラウザで開く）
maxPopupWidth = 400;	//ポップアップの最大横サイズ(デフォルトのテンプレートは400に合わせて作られている)
zero_date = 1;			//日付の桁揃えをするかどうか(0：しない、1：する)
zero_time = 1;			//時間の桁揃えをするかどうか(0：しない、1：する)
comment_cc = 300;		//表示する投稿者コメントの最大文字数(0で無制限)
tag_separater = '&nbsp;&nbsp;';	//タグの区切り文字(スペースは&nbsp;)

//スクリプト実行中にステータスバーに表示
v2c.setStatus('PopupStatusYoutubeスクリプト実行中...');

//JAVAパッケージのインポート
importPackage(javax.xml.parsers);
importPackage(org.w3c.dom);

//ステータスの変数
vid = '';						//動画ID
thumb = '';						//サムネイルURL
title = '';						//動画タイトル
date = '';						//投稿日時
	ye = '';					//西暦
	mo = '';					//月
	da = '';					//日
	ho = '';					//時
	mi = '';					//分
	se = '';					//秒
	ms = '';					//ミリ秒 ※多分常に0
name = '';						//投稿者名
uri = '';						//投稿者URI
keywords = '';					//キーワード(タグ)
time = '';						//再生時間
viewCount = '';					//再生回数
favCount = '';					//お気に入り数

//javaのStringオブジェクトはjavascriptの文字列とは異なる
//javascriptのlengthプロパティを参照するとエラーが出る
//その為JavaのStringオブジェクトを使用し、length()メソッドを使う
comment = new java.lang.String('説明はありません');//投稿者コメント

//実行
PopupStatusYoutube();

//リンククリック時に呼ばれる関数
function redirectURL( u ) {
	if ( u ) {
		//ポップアップを再度開く
		if ( !closePopup ) {
			v2c.context.setPopupHTML( stream );
			v2c.context.setMaxPopupWidth(maxPopupWidth);
			v2c.context.setRedirectURL( true );
		}
		//外部ブラウザで開く
		if ( browseExt ) {
			v2c.browseURLExt( u );
		}
		//JDICがあれば内部ブラウザで開く
		else{
			v2c.browseURL( u );
		}
	}
	return;
}

function PopupStatusYoutube() {
	//ポップアップIDの初期化
	var pid = 'idstring';
	
	//URLオブジェクトの取得
	var url = v2c.context.link;	

	//URLオブジェクトがあるかどうかの確認
	if (!url ){
		v2c.print( 'URL取得失敗\n\n' );
		return;
	}

	//URLがYoutubeかどうか
	if( url.toString().match( /http:\/\/www\.youtube\.com\/watch(_videos)?\?v=([\-\w]{11})(.+)?/i ) ) {
		vid = RegExp.$2;
		var xmlUrl = 'http://gdata.youtube.com/feeds/api/videos/' + vid;
	}
	else{
		v2c.print( 'YoutubeのURLではない' );
	}

	//同じURLのポップアップを開いていたら終了
	if ( v2c.context.getPopupOfID( vid ) ) {
		return;
	}

	//XML DOMオブジェクトの作成
	try {
		var dbf = DocumentBuilderFactory.newInstance();
		var db = dbf.newDocumentBuilder();
	    var doc = db.parse( xmlUrl );//YouTube Data APIからXMLをGETする
	}
	catch (e) {
		v2c.print( 'XMLDOM Error\n' + e + '\nHTTP 400 : 不正なリクエスト\nHTTP 403 : 動画が削除されている、またはアクセス拒否\n\n' );
		return;
	}
	
	//XML解析
	traceNodes( doc );
	
	//サムネイルURLの取得
	thumb = 'http://img.youtube.com/vi/' + vid + '/1.jpg';
	
	//投稿者URIの取得
	uri = 'http://www.youtube.com/user/' + name;
	
	//投稿日時をUTC→ローカル時間に ISO8601形式 例:2010-01-01T00:00:00.000Z
	if( date.match( /(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})\.(\d{3})Z/ ) ) {
		var dd = new Date( RegExp.$1, RegExp.$2, RegExp.$3, RegExp.$4, RegExp.$5, RegExp.$6, RegExp.$7 );
		//toString()によってローカル時間に変換される
		//日本の場合は-9時間
		ye = dd.getUTCFullYear().toString();
		mo = dd.getUTCMonth().toString();
		da = dd.getUTCDate().toString();
		ho = dd.getUTCHours().toString();
		mi = dd.getUTCMinutes().toString();
		se = dd.getUTCSeconds().toString();
		ms = dd.getUTCMilliseconds().toString();
		
		//12月が0月になるのを修正
		if(mo == '0'){
			mo = '12';
		}
		
		//日付の桁揃え
		if ( zero_date ) {
			mo = zeroPlus( mo );
			da = zeroPlus( da );
		}
		
		//時間の桁揃え
		if (zero_time) {
			ho = zeroPlus( ho );
			mi = zeroPlus( mi );
			se = zeroPlus( se );
		}
	}
	
	//キーワードにリンクを付ける
	var tmp;
	keywords = keywords.replace( ' ', '' );
	keywords = keywords.replace( '　', '' );
	tmp = keywords.split( ',' );
	
	//keywordsが空の場合でもtmp.lengthが1になるため、処理を分岐
	if ( keywords != '' ) {
		keywords = '';
		for ( var i = 0; i < tmp.length; i++ ) {
			keywords = keywords + '<a href="http://www.youtube.com/results?search_query='
						+ encodeURIComponent( tmp[i] ) + '&search=tag">'
						+ tmp[i] + '</a>' + tag_separater;
		}
	}

	//再生時間の整形
	time = zeroPlus(parseInt(time/3600)) + ':' 
			+ zeroPlus(parseInt((time%3600)/60)) + ':' 
			+ zeroPlus((time%3600)%60);
			
	//コメントの文字数制限の適用
	if ( comment_cc ) {
		if ( comment.length() > comment_cc){
			comment = comment.slice(0,comment_cc) + '...';
		}
	}
	
	//テンプレートを読み込み
	stream = v2c.readFile( v2c.saveDir + '\\script\\PopupStatusYoutube\\template.txt' );
	
	//置換文字に「$」が入っているとエラーが出る問題の修正
	title = title.replace( '\$', '＄');
	comment = comment.replace( '\$', '＄');
	keywords = keywords.replace( '\$', '＄');
	
	//パラメータの置換
	stream = stream.replaceAll( '%vid%', vid );
	stream = stream.replaceAll( '%thumb%', thumb );
	stream = stream.replaceAll( '%title%', title );
	stream = stream.replaceAll( '%ye%', ye );
	stream = stream.replaceAll( '%mo%', mo );
	stream = stream.replaceAll( '%da%', da );
	stream = stream.replaceAll( '%ho%', ho );
	stream = stream.replaceAll( '%mi%', mi );
	stream = stream.replaceAll( '%comment%', comment );
	stream = stream.replaceAll( '%name%', name );
	stream = stream.replaceAll( '%uri%', uri );
	stream = stream.replaceAll( '%keywords%', keywords );
	stream = stream.replaceAll( '%time%', time );
	stream = stream.replaceAll( '%viewCount%', viewCount );
	stream = stream.replaceAll( '%favCount%', favCount );
	stream = stream.replaceAll( '%movie%', url );

	//ポップアップの設定
	v2c.context.setPopupHTML( stream );
	v2c.context.setMaxPopupWidth( maxPopupWidth );
	v2c.context.setRedirectURL( true );
	v2c.context.setPopupID( vid );

	//v2c.alert(title+'\n'+date+'\n'+comment+'\n'+name+'\n'+uri+'\n'+thumb+'\n'+viewCount+'\n'+favCount+'\n'+time+'\n'+keywords);
}

//全てのXMLノードを走査
function traceNodes( node ) {

	var child = node.getFirstChild();

	//子ノードが無くなるまで繰り返し
	while ( child != null ) {

		//ノードが持つ属性(NamedNodeMap)
		var attrs = child.getAttributes();

		//動画タイトルの取得 <title>
		if ( child.getNodeName() == 'title' ) {
			//child.getNodeValue()ではnullになる
			//※あるタグの中の文字列は、そのタグの子ノードである
			title = child.getFirstChild().getNodeValue();
		}

		//投稿日時の取得 <published>
		if ( child.getNodeName() == 'published' ) {
			date = child.getFirstChild().getNodeValue();
		}

		//投稿者コメントの取得
		if ( child.getNodeName() == 'content' ) {
			//存在しない場合もある為、存在チェック
			if( child.getFirstChild() ) {
				comment = child.getFirstChild().getNodeValue();
			}
		}

		//投稿者名の取得
		if ( child.getNodeName() == 'name' ) {
				name = child.getFirstChild().getNodeValue();
		}

		//キーワード(タグ)の取得
		if ( child.getNodeName() == 'media:keywords' ) {
			//存在しない場合もある為、存在チェック
			if( child.getFirstChild() ) {
				keywords = child.getFirstChild().getNodeValue();
			}
		}

		//再生時間の取得
		if ( child.getNodeName() == 'yt:duration'){
			//タグの属性として格納されている
			if(attrs){
				//再生時間(秒)の取得
				if( attrs.getNamedItem('seconds') ){
					time = attrs.getNamedItem('seconds').getNodeValue();
				}
			}
		}

		//再生回数、お気に入り数の取得
		if ( child.getNodeName() == 'yt:statistics'){
			if(attrs){
				//再生回数の取得
				if( attrs.getNamedItem('viewCount') ){
					viewCount = attrs.getNamedItem('viewCount').getNodeValue();
				}
				//お気に入り数の取得
				if( attrs.getNamedItem('favoriteCount') ){
					favCount = attrs.getNamedItem('favoriteCount').getNodeValue();
				}
			}
		}

		
		//再帰関数
		traceNodes( child );
		child = child.getNextSibling();
	}
	return;
}

function zeroPlus(str) {
	return ( '0' + str ).slice(-2);
}
// ----- 前の行まで -----